Ruby master - Feature #9711

Remove test-unit and minitest from stdlib.
04/07/2014 12:59 PM - hsbt (Hiroshi SHIBATA)

Status: Closed

Priority: Normal

Assignee: zenspider (Ryan Davis)
Target version: 2.2.0

Description

ref. #9660

We are hard to maintain test-unit and minitest for standard library.
| poropose to remove to their from stdlib.

see also my patches: https://github.com/hsbt/ruby/compare/extracted-test-suite?expand=1

my solution is that test-unit and minitest move to test directory.
their are used only ruby-core tests.

If people hope to use test-unit and minitest, they can download their from rubygems.

Related issues:
Related to Ruby master - Bug #9660: test/unit, minitest & bundler Closed 03/21/2014

Associated revisions

Revision f8c6a5dc - 05/17/2014 06:26 AM - hsbt (Hiroshi SHIBATA)

e test/runner.rb: remove dependency test-unit and minitest from stdlib when running with test-all. [Feature #9711][ruby-core:61890]
¢ test/testunit/*.rb: ditto.
o test/lib: ditto.

git-svn-id: svn+ssh:/ci.ruby-lang.org/ruby/trunk@45970 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 45970 - 05/17/2014 06:26 AM - hsbt (Hiroshi SHIBATA)

e test/runner.rb: remove dependency test-unit and minitest from stdlib when running with test-all. [Feature #9711][ruby-core:61890]
e test/testunit/*.rb: ditto.
¢ test/lib: ditto.

Revision 45970 - 05/17/2014 06:26 AM - hsbt (Hiroshi SHIBATA)

e test/runner.rb: remove dependency test-unit and minitest from stdlib when running with test-all. [Feature #9711][ruby-core:61890]
e test/testunit/*.rb: ditto.
¢ test/lib: ditto.

Revision 45970 - 05/17/2014 06:26 AM - hsbt (Hiroshi SHIBATA)

e test/runner.rb: remove dependency test-unit and minitest from stdlib when running with test-all. [Feature #9711][ruby-core:61890]
e test/testunit/*.rb: ditto.
¢ test/lib: ditto.

Revision 45970 - 05/17/2014 06:26 AM - hsbt (Hiroshi SHIBATA)

e test/runner.rb: remove dependency test-unit and minitest from stdlib when running with test-all. [Feature #9711][ruby-core:61890]
e test/testunit/*.rb: ditto.
¢ test/lib: ditto.

Revision 45970 - 05/17/2014 06:26 AM - hsbt (Hiroshi SHIBATA)

e test/runner.rb: remove dependency test-unit and minitest from stdlib when running with test-all. [Feature #9711][ruby-core:61890]
e test/testunit/*.rb: ditto.
e test/lib: ditto.

Revision 45970 - 05/17/2014 06:26 AM - hsbt (Hiroshi SHIBATA)

e test/runner.rb: remove dependency test-unit and minitest from stdlib when running with test-all. [Feature #9711][ruby-core:61890]

¢ test/testunit/*.rb: ditto.
e test/lib: ditto.

Revision 96155267 - 05/17/2014 08:01 AM - sorah (Sorah Fukumori)

e lib/test: Removed because ruby's test cases now independent to lib/test by r45970. [Feature #9711] [ruby-core:62620]

I'm still considering about the future of lib/minitest, lib/test.
(bundling gems?)

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@45974 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 45974 - 05/17/2014 08:01 AM - sorah (Sorah Fukumori)

e lib/test: Removed because ruby's test cases now independent to lib/test by r45970. [Feature #9711] [ruby-core:62620]

I'm still considering about the future of lib/minitest, lib/test.
(bundling gems?)

Revision 45974 - 05/17/2014 08:01 AM - sorah (Sorah Fukumori)

¢ lib/test: Removed because ruby's test cases now independent to lib/test by r45970. [Feature #9711] [ruby-core:62620]

I'm still considering about the future of lib/minitest, lib/test.
(bundling gems?)

Revision 45974 - 05/17/2014 08:01 AM - sorah (Sorah Fukumori)

¢ lib/test: Removed because ruby's test cases now independent to lib/test by r45970. [Feature #9711] [ruby-core:62620]

I'm still considering about the future of lib/minitest, lib/test.
(bundling gems?)

Revision 45974 - 05/17/2014 08:01 AM - sorah (Sorah Fukumori)

e lib/test: Removed because ruby's test cases now independent to lib/test by r45970. [Feature #9711] [ruby-core:62620]

I'm still considering about the future of lib/minitest, lib/test.
(bundling gems?)

Revision 45974 - 05/17/2014 08:01 AM - sorah (Sorah Fukumori)

¢ lib/test: Removed because ruby's test cases now independent to lib/test by r45970. [Feature #9711] [ruby-core:62620]

I'm still considering about the future of lib/minitest, lib/test.
(bundling gems?)

Revision 45974 - 05/17/2014 08:01 AM - sorah (Sorah Fukumori)

¢ lib/test: Removed because ruby's test cases now independent to lib/test by r45970. [Feature #9711] [ruby-core:62620]

I'm still considering about the future of lib/minitest, lib/test.
(bundling gems?)

Revision 442879¢b - 05/19/2014 05:07 AM - sorah (Sorah Fukumori)

® bin/testrb: Removed. Forgot to remove in r45971. [Feature #9711] [ruby-core:62620]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@46011 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 46011 - 05/19/2014 05:07 AM - sorah (Sorah Fukumori)
e bin/testrb: Removed. Forgot to remove in r45971. [Feature #9711] [ruby-core:62620]
Revision 46011 - 05/19/2014 05:07 AM - sorah (Sorah Fukumori)

¢ bin/testrb: Removed. Forgot to remove in r45971. [Feature #9711] [ruby-core:62620]
Revision 46011 - 05/19/2014 05:07 AM - sorah (Sorah Fukumori)

¢ bin/testrb: Removed. Forgot to remove in r45971. [Feature #9711] [ruby-core:62620]
Revision 46011 - 05/19/2014 05:07 AM - sorah (Sorah Fukumori)

e bin/testrb: Removed. Forgot to remove in r45971. [Feature #9711] [ruby-core:62620]
Revision 46011 - 05/19/2014 05:07 AM - sorah (Sorah Fukumori)

¢ bin/testrb: Removed. Forgot to remove in r45971. [Feature #9711] [ruby-core:62620]
Revision 46011 - 05/19/2014 05:07 AM - sorah (Sorah Fukumori)

¢ bin/testrb: Removed. Forgot to remove in r45971. [Feature #9711] [ruby-core:62620]

History

#1 - 04/07/2014 10:20 PM - hsbt (Hiroshi SHIBATA)
- Tracker changed from Bug to Feature

- Target version set to 2.2.0

#2 - 04/11/2014 09:50 AM - vo.x (Vit Ondruch)

| wholeheartedly support this idea.

#3 - 04/13/2014 06:15 AM - wanabe (_ wanabe)
- Related to Bug #9660: test/unit, minitest & bundler added

#4 - 04/22/2014 12:44 AM - sorah (Sorah Fukumori)

| agree to do this :+1:

#5 - 04/22/2014 02:37 AM - naruse (Yui NARUSE)

We discussed about this on DevelopersMeeting20140418Japan:

e we use test/unit (with minitest) for our test-all -> we can solve it easy
¢ minitest4 conflicts with minitest5/minitest.gem

Conclusion

e hsbt separates test library for test-all and copy it to test/
e sora_h decide how handle llib/test/unit
¢ ryan decide how handle lib/minitest

#6 - 04/26/2014 08:36 AM - hsbt (Hiroshi SHIBATA)

- File copy-test-unit-minitest.patch added

| update my patch. this patch copy test-unit and minitest to test/lib and separate to dependecy from stdlib.
Could someone review this patch?

#7 - 05/01/2014 12:46 AM - zenspider (Ryan Davis)

Sorry it has taken me so long to respond. Sometimes | am slow at
choosing my words.

We are hard to maintain test-unit and minitest for standard library.
| poropose to remove to their from stdlib.

I'm not against moving minitest & test-unit into test for the sake of
maintainability.

| AM against shipping ruby without a testing library.

The Ruby community has a long history and culture centered around
testing. Removing all testing libraries from ruby betrays that culture
we've spent so long developing. It would be a shame to ship a ruby
that didn't support testing out of the box.

Ruby currently ships with minitest 4.7.5 and nobu/shota's "test-unit"
(quoted because, AFAIK, it is unrelated to the real test-unit gem
maintained by Kouhei Sutou). Test-unit is completely dependent on the
internals of minitest 4 to the point that | can't update minitest to

the latest version (5.3.3). In fact, I've accidentally broken

test-unit in the past when | updated lib/minitest. | don't want to do

this again.

| would be happy to have minitest 4 move to the test/minitest and even
have it merged completely with test/test-unit. | relinquish ownership

of test/minitest and consider it part of test/test-unit. | won't

maintain it further as I'm afraid of breaking test-unit and/or the

tests.

| would like to further propose that ruby still ship with minitest and
I would like to update that to minitest 5 (at some point, it doesn't
have to be now).

However, | do NOT think it should ship as lib/minitest. As we've seen,
there is too much incompatibility & confusion with gems shipping in
lib/. I've had numerous problems with rake, rdoc, and minitest because
of this. I'm sure I'm not alone in this.

I would like the packaging / installation process to be extended so

that these packages are all installed as real gems the same way any

other gem is installed. Upgrading, cleanup, and load paths should all

be done the same way they're normally done via rubygems. The gem specs
should not be modified. There should be zero difference between what

is installed by a ruby install and the actual gem of the same version.

| understand that this is a separate issue and am happy to file a new

ticket.

Summary:
e Agree to move lib/minitest and lib/test into test/*.
¢ | relinquish ownership of test/minitest and propose it be merged directly into test/test-unit.

e |'d like to update ruby to ship with minitest 5, as a real gem.
¢ |'d also like all the other bundled gems to ship as real gems.

#8 - 05/01/2014 05:22 AM - duerst (Martin Diirst)

Ryan Davis wrote:
Sorry it has taken me so long to respond. Sometimes | am slow at
choosing my words.

Maybe slow, but | think you choose your words very well.
| AM against shipping ruby without a testing library.
The Ruby community has a long history and culture centered around
testing. Removing all testing libraries from ruby betrays that culture

we've spent so long developing. It would be a shame to ship a ruby
that didn't support testing out of the box.

This is very well put. | have said something similar at the most recent Ruby committers' meeting. | strongly agree with this. If Ruby comes with (e.g.)
Rational and Complex built in, but without any testing functionality, that would be fundamentally wrong.

Ryan, I'd encourage you to open features for your proposals.
#9 - 05/01/2014 11:44 PM - zenspider (Ryan Davis)
BTW, the patch looks fine to me. Should it not do deletes from lib/* ?

#10 - 05/16/2014 01:59 PM - hsbt (Hiroshi SHIBATA)

the patch looks fine to me. Should it not do deletes from lib/* ?

Thanks for your review. I'll commit this tomorrow.
Please update or remove minitest library from lib/*.
| already noticed it @sora_h.

#11 - 05/17/2014 06:27 AM - hsbt (Hiroshi SHIBATA)
- Status changed from Open to Closed
- % Done changed from 0 to 100

Applied in changeset r45970.

e test/runner.rb: remove dependency test-unit and minitest from stdlib when running with test-all. [Feature #9711][ruby-core:61890]

e test/testunit/*.rb: ditto.
¢ test/lib: ditto.

#12 - 05/17/2014 11:37 AM - hsbt (Hiroshi SHIBATA)
- Status changed from Closed to Open

- Assignee set to zenspider (Ryan Davis)

Hi, Ryan.

| and sora_h removed test-unit from stdlib.
Please remove minitest from stdlib too.

I would like the packaging / installation process to be extended so
that these packages are all installed as real gems the same way any
other gem is installed.

Sorry, | missed your above comments.
Today, We(Ruby committers) discussed your opinion.
We agreed that ruby shouldn't be release without test library.

But We have no solution yet. we need to discuss continuously.
I'll create follow tickets.

1. Should we bundle test-unit2(http://rubygems.org/gems/test-unit)?
2. Should we make gem installation mechanism with packaging?

These are main discussion theme at next developer meeting.
| coordinate it.

Thanks.
#13 - 05/18/2014 07:58 AM - sorah (Sorah Fukumori)
| agree that we should package testing library (at least one).

| prefer bundling test-unit2 and minitest5 gem in Ruby 2.2 --

if they have some backward compatibility or they're easy to upgrade from older versions.

I'd like to hear opinion from Kou (author of test-unit.gem) and Ryan. Thoughts?

#14 - 05/19/2014 05:07 AM - sorah (Sorah Fukumori)
- Status changed from Open to Closed

Applied in changeset r46011.
® bin/testrb: Removed. Forgot to remove in r45971. [Feature #9711] [ruby-core:62620]
#15 - 05/19/2014 12:12 PM - kou (Kouhei Sutou)
hsbt and sora_h, thanks for your works.

I'd like to hear opinion from Kou (author of test-unit.gem) and Ryan. Thoughts?

Should we comment about it on this ticket? Or on new tickets about them?

1. Should we bundle test-unit2(http://rubygems.org/gems/test-unit)?
2. Should we make gem installation mechanism with packaging?

| think that new tickets are better.

#16 - 05/19/2014 12:15 PM - hsbt (Hiroshi SHIBATA)

- Status changed from Closed to Assigned

#17 - 05/23/2014 11:53 PM - zenspider (Ryan Davis)
- Status changed from Assigned to Closed
I've removed lib/minitest in r46064

I've commented on ticket #9852 on what | think needs to happen, but I'd need help from someone who knows the build system intricacies to actually
do this myself.

Closing this ticket.

Files

copy-test-unit-minitest.patch 140 KB 04/26/2014 hsbt (Hiroshi SHIBATA)
